#!/usr/bin/perl

#Must be run from directory containing the .pto files

$pwd = `pwd`;
chomp($pwd);
$datadir = $pwd . "/data/noon";

mkdir("out");

opendir(DATAD,$datadir);
@dirs = grep { $_ =~ /^2/ && -d "$datadir/$_" } readdir(DATAD);
closedir(DATAD);

@dirs = sort(@dirs);

opendir(PTODIR,".");
@ptofiles = grep { $_ =~ /^\d+.*\.pto/ && -f "./$_" } readdir(PTODIR);
closedir(PTODIR);

@ptofiles = sort(@ptofiles);

mk_ptolist();

foreach $dir (@dirs) {
  print "$dir\n";
  $pto = find_pto($dir);
  if ($pto ne "") {
    print " using segment $pto\n";
  }
  else {
    print " no segment found, skipping\n";
    next;
  }
  system("ln -sf $pto curr.pto");
  chdir("in");
  system("ln -sf $datadir/$dir/webcam-gates1* left.jpg");
  system("ln -sf $datadir/$dir/webcam-gates2* right.jpg");
  chdir("..");
  system("nona -z PACKBITS -r ldr -m TIFF_m -o foo -i 1 curr.pto");
  system("nona -z PACKBITS -r ldr -m TIFF_m -o foo -i 2 curr.pto");
  system("enblend -f1218x1100 -o foo.tif foo0001.tif foo0002.tif");
  system("mv foo.tif out/${dir}.tif");
}

exit;

sub mk_ptolist
{
  @pto_starts = ();
  @pto_ends = ();
  @ptos = ();
  print "Loading segments:\n";
  foreach my $ptofile (@ptofiles) {
    next if ($ptofile !~ /^(\d{4}-\d{2}-\d{2})--(\d{4}-\d{2}-\d{2})\.pto$/);
    my $start = $1;
    my $end = $2;
    print "  start = $start, end = $end\n";
    push(@pto_starts, $start);
    push(@pto_ends, $end);
    push(@ptos, $ptofile);
  }
}

sub find_pto
{
  my $date = $_[0];
  my $i;
  for ($i = 0; $i <= $#pto_starts; $i++) {
    last if (($date cmp $pto_starts[$i]) >= 0 && ($date cmp $pto_ends[$i]) <= 0);
  }
  if ($i > $#pto_starts) {
    return "";
  }
  else {
    return $ptos[$i];
  }
}

